import { Class, TSObject } from "./tsobject";
import { Comparison, StringDictionary, uint, uint8 } from "./types";
export declare const TSWebColorNames: StringDictionary;
export declare function $lighter(c: number): uint8;
export declare function $darker(c: number): uint8;
export declare function $lightest(c: number): uint8;
export declare function $darkest(c: number): uint8;
/**
 * TSColor are immutable objects which are cached (if you use TSColor.color())
 * better
 */
export declare class TSColor implements TSObject<TSColor> {
    readonly red: uint8;
    readonly green: uint8;
    readonly blue: uint8;
    readonly alpha: uint8;
    private _name?;
    private static __colorsCache;
    private static readonly __colorCacheMaxSize;
    static readonly red: TSColor;
    static readonly green: TSColor;
    static readonly yellow: TSColor;
    static readonly blue: TSColor;
    static readonly cyan: TSColor;
    static readonly magenta: TSColor;
    static readonly white: TSColor;
    static readonly black: TSColor;
    static darkWriteColor: TSColor;
    static lightWriteColor: TSColor;
    static color(): TSColor;
    static color(stringColor: string): TSColor;
    static color(colorDefinition: number): TSColor;
    static color(r: number, g: number, b: number, a?: number): TSColor;
    constructor(stringColor: string);
    constructor(stringColor: string, dontCheckCache?: boolean);
    constructor(colorDefinition: number);
    constructor(r: number, g: number, b: number, a?: number);
    get name(): string;
    clone(): TSColor;
    luminance(): number;
    isPale(): boolean;
    alphaColor(alpha: uint8): TSColor;
    lighterColor(): TSColor;
    darkerColor(): TSColor;
    lightestColor(): TSColor;
    darkestColor(): TSColor;
    matchingColor(): TSColor;
    writingColor(): TSColor;
    toNumber(): number;
    toUnsigned(): uint;
    get isa(): Class<TSColor>;
    get className(): string;
    isEqual(other: any): boolean;
    compare(other: any): Comparison;
    shortestCSSString(): string;
    toString(removeAlpha?: boolean): string;
    toJSON(): string;
    toArray(): uint8[];
    private static _cacheColor;
    private static _cachedColor;
}
